classification
Title: HTTP/1.1 with keep-alive support for xmlrpclib.ServerProxy
Type: performance Stage:
Components: Library (Lib) Versions: Python 3.0, Python 2.7
process
Status: closed Resolution: out of date
Dependencies: Superseder: Cumulative patcc:h to http and xmlrpc
View: 6267
Assigned To: Nosy List: kristjan.jonsson, loewis
Priority: normal Keywords: needs review, patch

Created on 2009-05-24 20:52 by kristjan.jonsson, last changed 2009-06-20 16:28 by loewis. This issue is now closed.

Files
File name Uploaded Description Edit
xmlprclib.patch kristjan.jonsson, 2009-05-24 20:52
keepalive.patch kristjan.jonsson, 2009-05-25 10:33
xmlprclib.patch kristjan.jonsson, 2009-06-08 13:31
Messages (4)
msg88283 - (view) Author: Kristján Valur Jónsson (kristjan.jonsson) * (Python committer) Date: 2009-05-24 20:52
The Transport class in xmlrpclib.py was using the old httplib.HTTP 
class.
This patch brings xmlrpclib up to date to use the HTTPConnection and 
HTTPSConnection classes.  This allows xlmrpclib.ServerProxy to use 
HTTP/1.1 with keep-alive on
servers that support it.

Note that this patch benefits from recent optimizations of 
HTTPConnection reducing the Nagle problem.

This is a separate patch from http://bugs.python.org/issue1767370 and in 
my opinion much simpler.
See also 
http://bugs.python.org/issue2076

Patch uploaded as http://codereview.appspot.com/63144
msg88316 - (view) Author: Kristján Valur Jónsson (kristjan.jonsson) * (Python committer) Date: 2009-05-25 10:33
I attach another patch, keepalive.patch, which includes the fixes from http://bugs.python.org/issue6096 and including a test for the keepalive 
mecahinsm in the test suite.

Updated http://codereview.appspot.com/63144
msg89078 - (view) Author: Kristján Valur Jónsson (kristjan.jonsson) * (Python committer) Date: 2009-06-08 13:31
It turns out we need to deal with exceptions and clear the cached 
HTTPConnection if they happen.
Also, we just deal with a ECONNRESET which can happen if there is a long 
delay between requests, and retry the request once in that case.  New 
patch uploaded.
msg89542 - (view) Author: Martin v. Löwis (loewis) * (Python committer) Date: 2009-06-20 16:28
Superseded by issue6267.
History
Date User Action Args
2009-06-20 16:28:08loewissetstatus: open -> closed

superseder: Cumulative patcc:h to http and xmlrpc

keywords: patch, patch, needs review
nosy: + loewis
messages: + msg89542
resolution: out of date
2009-06-08 13:31:47kristjan.jonssonsetkeywords: patch, patch, needs review
files: + xmlprclib.patch
messages: + msg89078
2009-05-25 10:34:02kristjan.jonssonsetkeywords: patch, patch, needs review
files: + keepalive.patch
messages: + msg88316
2009-05-24 20:52:11kristjan.jonssoncreate